@ECHO OFF
REM #
REM # IBM Confidential 
REM #	
REM #   (c) Copyright IBM Corp. 2000, 2008 All Rights Reserved.
REM #
REM #   The source code for this program is not published or otherwise
REM #   divested of its trade secrets, irrespective of what has been 
REM #   deposited with the U.S. Copyright Office.

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::   
:: OVERVIEW:
:: Note this script is called to start the RQM adapter.
::
:: USAGE  startadapter.bat 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

setlocal enableextensions enabledelayedexpansion

SET DEBUG_OUTPUT=..false..

SET THIS_BATCH_FILES_DIR=%~dp0
SET ARG_JRE=..undefined..
SET JVM_ARGS=..undefined..
SET RREG_DIR=..undefined..
SET RREG=rreg.exe
SET INSTALL_DIR=..undefined..


shift
CALL :Setrreg
CALL :Debug Set RREG_DIR=%RREG_DIR%
CALL :SetInstallDir
CALL :SetJre
CALL :Debug ARG_JRE=%ARG_JRE%
CALL :RunLog %*
GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: setrreg - Set the rreg variable which will point to the rreg.exe. This will help  
:: to get the registry variables.
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:Setrreg
IF %RREG_DIR% NEQ ..undefined.. (
	GOTO :EOF
)
IF EXIST "%THIS_BATCH_FILES_DIR%..\installscripts\%RREG%"	(
	SET RREG_DIR=!THIS_BATCH_FILES_DIR!..\installscripts
) ELSE ( 
	IF EXIST "%IBM_RATIONAL_RFT_INSTALL_DIR%\..\installscripts\%RREG%"	(
		SET RREG_DIR=!IBM_RATIONAL_RFT_INSTALL_DIR!\..\installscripts
	) ELSE (
		IF EXIST "%THIS_BATCH_FILES_DIR%\%RREG%"	(
			Set RREG_DIR=!THIS_BATCH_FILES_DIR!
		) 
	)
)

CALL :Debug Set RREG_DIR=%RREG_DIR%

GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: setInstallDir
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: 
:SetInstallDir
IF %INSTALL_DIR% NEQ ..undefined.. (
	GOTO :EOF
)
IF EXIST "%IBM_RATIONAL_RFT_INSTALL_DIR%" (
	Set INSTALL_DIR=!IBM_RATIONAL_RFT_INSTALL_DIR!
) ELSE (
	@CALL :QueryRftReg "Rational FT Install Directory"
	@IF "%REG_VALUE%" NEQ "" (
		Set INSTALL_DIR=!REG_VALUE!
	)
)
CALL :Debug Set INSTALL_DIR=%INSTALL_DIR%
GOTO :EOF
	
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: setjre
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: 
:SetJre
IF %ARG_JRE% NEQ ..undefined.. (
	GOTO :EOF
)
@CALL :QueryRftReg "Rational FT JRE"
@IF "%REG_VALUE%" NEQ "" (
	IF EXIST "%REG_VALUE%\bin\javaw.exe" (
		Set ARG_JRE=!REG_VALUE!\bin\java.exe
		GOTO :EOF
	)
)
@CALL :QueryRftReg "Rational FT Install Directory"  
@IF "%REG_VALUE%" NEQ "" (
	IF EXIST "%REG_VALUE%\..\..\jdk\jre\bin\java.exe" (
		Set ARG_JRE=!REG_VALUE!\..\..\jdk\jre\bin\java.exe
		GOTO :EOF
	)
	IF EXIST "%REG_VALUE%\..\..\jre\bin\java.exe" (
		Set ARG_JRE=!REG_VALUE!\..\..\jre\bin\java.exe
		GOTO :EOF
	)
)
IF "%INSTALL_DIR%" NEQ "..undefined.." (
	IF EXIST "%INSTALL_DIR%\..\..\jdk\jre\bin\java.exe" ( 
		Set ARG_JRE=!INSTALL_DIR!\..\..\jdk\jre\bin\java.exe
		GOTO :EOF
	)
	IF EXIST "%INSTALL_DIR%\..\..\jre\bin\java.exe" ( 
		Set ARG_JRE=!INSTALL_DIR!\..\..\jre\bin\java.exe
		GOTO :EOF
	)
)
IF "%JAVA2_HOME%" NEQ "" (
	IF EXIST "%JAVA2_HOME%\jre\bin\java.exe" ( 
		Set ARG_JRE=!JAVA2_HOME!\jre\bin\java.exe
		GOTO :EOF
	)
)
Set ARG_JRE=java.exe
GOTO :EOF

:RunLog
@ECHO Running "%ARG_JRE%" -classpath "%INSTALL_DIR%\rational_ft.jar" com.rational.test.ft.FtLog -zlog %1
"%ARG_JRE%" -classpath "%INSTALL_DIR%\rational_ft.jar" com.rational.test.ft.FtLog -zlog %1
GOTO :EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Query Registry Variable
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:QueryReg
	IF "%RREG_DIR%" EQU "..undefined.." (
		@GOTO :EOF
	)

	CALL :Debug === QueryReg %1 %2
	SET REG_VALUE=
	pushd "%RREG_DIR%"
	for /f "delims== tokens=1-3" %%i in ('%RREG% query %1 /v %2 /p') do @SET REG_VALUE=%%j
	popd
	CALL :DEBUG Registry %2=%REG_VALUE%
	@GOTO :EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Query RFT Registry Variable
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:QueryRftReg
	@CALL :QueryReg "HKLM\SOFTWARE\Rational Software\Rational Test\8" %1
	@GOTO :EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Debug  Message
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:Debug
	@if %DEBUG_OUTPUT% EQU ..true.. (
		@ECHO DEBUG--- "%*"
	)
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Error Message
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:Error
	set ERR_CODE=..error..
	@ECHO ERROR - %*
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Error Message
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:ErrorNoStop
	set ERR_CODE=..success..
	@ECHO ERROR - %*
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Warning
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:Warning
	set ERR_CODE=..success..
	@ECHO WARNING - %*
	GOTO :EOF

:LAST
@echo "---------------------------------------------------------------------"
